Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/configuration.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/configuration.cfg	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/configuration.cfg	(revision 82)
@@ -3,5 +3,5 @@
 1	1	+1	# nb_front_end       
 2	2	+1	# nb_ooo_engine      
-1024	1024	+1	# nb_packet          
+256 	256 	+1	# nb_packet          
 32	32	+1	# size_general_data  
 32	32	+1	# nb_general_register
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/src/test.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/src/test.cpp	(revision 82)
@@ -7,37 +7,9 @@
  */
 
+#define NB_ITERATION  1
+#define CYCLE_MAX     (1024*NB_ITERATION)
+
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/include/test.h"
 #include "Common/include/Test.h"
-
-#define NB_ITERATION  1
-#define CYCLE_MAX     (1024*NB_ITERATION)
-
-#define LABEL(str...)							\
-  {									\
-    msg (_("{%d} "),static_cast<uint32_t>(sc_simulation_time()));	\
-    msg (str);								\
-    msg (_("\n"));							\
-  } while(0)
-
-#define SC_START(cycle_offset)                                                       \
-  do									             \
-    {									             \
-      /*cout << "SC_START (begin)" << endl;*/				             \
-									             \
-      uint32_t cycle_current = static_cast<uint32_t>(sc_simulation_time());          \
-      if (cycle_offset != 0)						             \
-	{								             \
-	  cout << "##########[ cycle "<< cycle_current+cycle_offset << " ]" << endl; \
-	}								             \
-									             \
-      if (cycle_current > CYCLE_MAX)					             \
-	{								             \
-	  TEST_KO("Maximal cycles Reached");				             \
-	}								             \
-									             \
-      sc_start(cycle_offset);						             \
-									             \
-      /*cout << "SC_START (end  )" << endl;*/				             \
-    } while(0)
 
 class execute_transaction
@@ -121,7 +93,8 @@
   Functionnal_unit * _Functionnal_unit = new Functionnal_unit (name.c_str(),
 #ifdef STATISTICS
-					     _parameters_statistics,
+							       _parameters_statistics,
 #endif
-					     _param);
+							       _param,
+							       USE_ALL);
   
 #ifdef SYSTEMC
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Functionnal_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Functionnal_unit.h	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Functionnal_unit.h	(revision 82)
@@ -148,5 +148,5 @@
 #endif
    Parameters                                  * param,
-   morpheo::behavioural::Tusage_t                usage=USE_ALL
+   morpheo::behavioural::Tusage_t                usage
    );
   public  :             ~Functionnal_unit         (void);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/include/test.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/include/test.h	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/include/test.h	(revision 82)
@@ -7,4 +7,5 @@
  */
 
+#define CYCLE_MAX     1024
 
 #include "Common/include/Time.h"
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/src/test1.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/src/test1.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/src/test1.cpp	(revision 82)
@@ -7,33 +7,8 @@
  */
 
+  /*
+
 #include <queue>
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/include/test.h"
-
-#define NB_ITERATION  1
-#define CYCLE_MAX     (1024*NB_ITERATION)
-
-#define LABEL(str)							\
-  {									\
-    cout << "{"+toString(static_cast<uint32_t>(sc_simulation_time()))+"} " << str << endl; \
-  } while(0)
-
-#define SC_START(cycle_offset)						\
-  do									\
-    {									\
-      /*cout << "SC_START (begin)" << endl;*/				\
-									\
-      uint32_t cycle_current = static_cast<uint32_t>(sc_simulation_time()); \
-      if (cycle_offset != 0)						\
-	{								\
-	  cout << "##########[ cycle "<< cycle_current+cycle_offset << " ]" << endl; \
-	}								\
-									\
-      if (cycle_current > CYCLE_MAX)					\
-	{								\
-	  TEST_KO("Maximal cycles Reached");				\
-	}								\
-      sc_start(cycle_offset);						\
-      /*cout << "SC_START (end  )" << endl;*/				\
-    } while(0)
 
 
@@ -55,7 +30,5 @@
   
 #ifdef SYSTEMC
-  /*********************************************************************
-   * Déclarations des signaux
-   *********************************************************************/
+
   string rename = "";
 
@@ -129,7 +102,5 @@
     }
   
-  /********************************************************
-   * Instanciation
-   ********************************************************/
+  // Instanciation
   
   cout << "<" << name << "> Instanciation of _Load_store_unit" << endl;
@@ -215,7 +186,5 @@
   Time * _time = new Time();
 
-  /********************************************************
-   * Simulation - Begin
-   ********************************************************/
+  // Simulation - Begin
 
   // Initialisation
@@ -656,5 +625,5 @@
 		}
 
-	      LABEL("DCACHE_RSP : "+toString(in_DCACHE_RSP_VAL->read())+" - "+toString(out_DCACHE_RSP_ACK ->read()));
+		LABEL("DCACHE_RSP : "+toString(in_DCACHE_RSP_VAL->read())+" - "+toString(out_DCACHE_RSP_ACK ->read()));
 	      if (in_DCACHE_RSP_VAL->read() and out_DCACHE_RSP_ACK->read())
 		{
@@ -677,7 +646,5 @@
 
   
-  /********************************************************
-   * Simulation - End
-   ********************************************************/
+  // Simulation - End
 
   TEST_OK ("End of Simulation");
@@ -755,2 +722,3 @@
 #endif
 }
+  */
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/src/test2.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/src/test2.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/src/test2.cpp	(revision 82)
@@ -9,31 +9,4 @@
 #include <queue>
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/include/test.h"
-
-#define CYCLE_MAX     1024
-
-#define LABEL(str)							\
-  {									\
-    cout << "{"+toString(static_cast<uint32_t>(sc_simulation_time()))+"} " << str << endl; \
-  } while(0)
-
-#define SC_START(cycle_offset)						\
-  do									\
-    {									\
-      /*cout << "SC_START (begin)" << endl;*/				\
-									\
-      uint32_t cycle_current = static_cast<uint32_t>(sc_simulation_time()); \
-      if (cycle_offset != 0)						\
-	{								\
-	  cout << "##########[ cycle "<< cycle_current+cycle_offset << " ]" << endl; \
-	}								\
-									\
-      if (cycle_current > CYCLE_MAX)					\
-	{								\
-	  TEST_KO("Maximal cycles Reached");				\
-	}								\
-      sc_start(cycle_offset);						\
-      /*cout << "SC_START (end  )" << endl;*/				\
-    } while(0)
-
 
 //===================================================================={test}
@@ -71,5 +44,6 @@
 							    _parameters_statistics,
 #endif
-							    _param);
+							    _param,
+							    USE_ALL);
   
 #ifdef SYSTEMC
@@ -487,10 +461,10 @@
 	      SC_START(0);
 
-	      LABEL("MEMORY_IN  : "+toString(in_MEMORY_IN_VAL ->read())+" - "+toString(out_MEMORY_IN_ACK ->read()));
+	      LABEL("MEMORY_IN  : %d - %d",in_MEMORY_IN_VAL ->read(),out_MEMORY_IN_ACK ->read());
 	      if ( in_MEMORY_IN_VAL ->read() and out_MEMORY_IN_ACK ->read())
 		{
 		  Tpacket_t  packet_id = in_MEMORY_IN_PACKET_ID->read();
 
-		  LABEL(" * Accepted MEMORY_IN  : " + toString(packet_id));
+		  LABEL(" * Accepted MEMORY_IN  : %d",packet_id);
 		  cout << fifo_request.top();
 
@@ -509,10 +483,10 @@
 		}
 
-	      LABEL("MEMORY_OUT : "+toString(out_MEMORY_OUT_VAL->read())+" - "+toString(in_MEMORY_OUT_ACK ->read()));
+	      LABEL("MEMORY_OUT : %d - %d",out_MEMORY_OUT_VAL->read(),in_MEMORY_OUT_ACK ->read());
 	      if (out_MEMORY_OUT_VAL->read() and  in_MEMORY_OUT_ACK->read())
 		{
 		  Tpacket_t  packet_id = out_MEMORY_OUT_PACKET_ID->read();
 
-		  LABEL(" * Accepted MEMORY_OUT : " + toString(packet_id));
+		  LABEL(" * Accepted MEMORY_OUT : %d",packet_id);
 
 		  if (is_operation_memory_store(tab_request[packet_id]._operation))
@@ -650,5 +624,5 @@
 		}
 
-	      LABEL("DCACHE_REQ : "+toString(out_DCACHE_REQ_VAL->read())+" - "+toString(in_DCACHE_REQ_ACK ->read()));
+	      LABEL("DCACHE_REQ : %d - %d",out_DCACHE_REQ_VAL->read(),in_DCACHE_REQ_ACK ->read());
 	      if (out_DCACHE_REQ_VAL->read() and  in_DCACHE_REQ_ACK->read())
 		{
@@ -665,5 +639,5 @@
 		  packet_id  = (out_DCACHE_REQ_PACKET_ID ->read())>>1;
 	      
-		  LABEL(" * Accepted DCACHE_REQ : " + toString(packet_id));
+		  LABEL(" * Accepted DCACHE_REQ : %d",packet_id);
 
 		  if (address >= size_memory)
@@ -676,5 +650,5 @@
 		    {
 		      rdata = _memory->access (context_id, address, out_DCACHE_REQ_TYPE->read(), out_DCACHE_REQ_WDATA->read());
-		      LABEL("   * rdata : " + toString(rdata));
+		      LABEL("   * rdata : 0x%x",rdata);
 		    }
 
@@ -699,5 +673,5 @@
 		}
 
-	      LABEL("DCACHE_RSP : "+toString(in_DCACHE_RSP_VAL->read())+" - "+toString(out_DCACHE_RSP_ACK ->read()));
+	      LABEL("DCACHE_RSP : %d - %d",in_DCACHE_RSP_VAL->read(),out_DCACHE_RSP_ACK ->read());
 	      if (in_DCACHE_RSP_VAL->read() and out_DCACHE_RSP_ACK->read())
 		{
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Load_store_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Load_store_unit.h	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Load_store_unit.h	(revision 82)
@@ -30,4 +30,5 @@
 #include "Behavioural/include/Vhdl.h"
 #endif
+#include "Behavioural/include/Usage.h"
 
 namespace morpheo {
@@ -48,7 +49,7 @@
     // -----[ fields ]----------------------------------------------------
     // Parameters
-  protected : const std::string       _name;
-
+  protected : const std::string  _name;
   protected : const Parameters * _param;
+  private   : const Tusage_t     _usage;
 
 #ifdef STATISTICS
@@ -202,5 +203,6 @@
    morpheo::behavioural::Parameters_Statistics * param_statistics,
 #endif
-   Parameters                                  * param );
+   Parameters                                  * param,
+   morpheo::behavioural::Tusage_t                usage );
   public  :          ~Load_store_unit             (void);
 					       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit.cpp	(revision 82)
@@ -20,15 +20,20 @@
 #undef  FUNCTION
 #define FUNCTION "Load_store_unit::Load_store_unit"
+  Load_store_unit::Load_store_unit 
+  (
 #ifdef SYSTEMC
-  Load_store_unit::Load_store_unit (sc_module_name name,
+   sc_module_name name,
 #else
-  Load_store_unit::Load_store_unit (string name,
+   std::string name,
 #endif
 #ifdef STATISTICS
-			  morpheo::behavioural::Parameters_Statistics * param_statistics,
+   morpheo::behavioural::Parameters_Statistics * param_statistics,
 #endif
-			  morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_execute_unit::execute_unit::load_store_unit::Parameters * param ):
-			      _name              (name)
-			      ,_param            (param)
+   morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_execute_unit::execute_unit::load_store_unit::Parameters * param ,
+   morpheo::behavioural::Tusage_t usage
+   ):
+    _name              (name)
+    ,_param            (param)
+    ,_usage (usage)
   {
     log_printf(FUNC,Load_store_unit,FUNCTION,"Begin");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_allocation.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_allocation.cpp	(revision 82)
@@ -26,5 +26,5 @@
     log_printf(FUNC,Load_store_unit,FUNCTION,"Begin");
 
-    _component   = new Component ();
+    _component   = new Component (_usage);
 
     Entity * entity = _component->set_entity (_name       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/src/test.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/src/test.cpp	(revision 82)
@@ -7,37 +7,10 @@
  */
 
-#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/include/test.h"
-#include "Common/include/Test.h"
-
 #define NB_ITERATION  1
 //64
 #define CYCLE_MAX     (1024*NB_ITERATION)
 
-#define LABEL(str)                                                                       \
-{                                                                                        \
-  cout << "{"+toString(static_cast<uint32_t>(sc_simulation_time()))+"} " << str << endl; \
-} while(0)
-
-static uint32_t cycle = 0;
-
-#define SC_START(cycle_offset)                                          \
-do                                                                      \
-{                                                                       \
-/*cout << "SC_START (begin)" << endl;*/                                 \
-                                                                        \
-  uint32_t cycle_current = static_cast<uint32_t>(sc_simulation_time()); \
-  if (cycle_current != cycle)                                           \
-    {                                                                   \
-      cycle = cycle_current;                                            \
-      cout << "##########[ cycle "<< cycle << " ]" << endl;             \
-    }                                                                   \
-                                                                        \
-  if (cycle_current > CYCLE_MAX)                                        \
-    {                                                                   \
-      TEST_KO("Maximal cycles Reached");                                \
-    }                                                                   \
-  sc_start(cycle_offset);                                               \
-/*cout << "SC_START (end  )" << endl;*/                                 \
-} while(0)
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/include/test.h"
+#include "Common/include/Test.h"
 
 void test (string name,
@@ -54,5 +27,6 @@
 					     _parameters_statistics,
 #endif
-					     _param);
+					     _param,
+					     USE_ALL);
   
 #ifdef SYSTEMC
@@ -362,5 +336,5 @@
   for (uint32_t iteration=0; iteration<NB_ITERATION; iteration ++)
     {
-      LABEL("Iteration "+toString(iteration));
+      LABEL("Iteration %d",iteration);
       int32_t percent_transaction_queue_in     = (rand()%45)+30;
       int32_t percent_transaction_queue_out    = (rand()%45)+30;
@@ -518,12 +492,12 @@
 	  SC_START(0);
 	  
-	  LABEL("Test     READ_QUEUE_IN  : "+toString(READ_QUEUE_IN_VAL->read())+","+toString(READ_QUEUE_IN_ACK->read()));
+	  LABEL("Test     READ_QUEUE_IN  : %d,%d",READ_QUEUE_IN_VAL->read(),READ_QUEUE_IN_ACK->read());
 	  if ((READ_QUEUE_IN_VAL->read() == 1) and
 	      (READ_QUEUE_IN_ACK->read() == 1))
 	    {
-	      LABEL("Accepted READ_QUEUE_IN  ["+toString(request_in)+"]");
+	      LABEL("Accepted READ_QUEUE_IN  [%d]",request_in);
 	      request_in  ++;
 	    }
-	  LABEL("Test     READ_QUEUE_OUT : "+toString(READ_QUEUE_OUT_VAL->read())+","+toString(READ_QUEUE_OUT_ACK->read()));
+	  LABEL("Test     READ_QUEUE_OUT : %d,%d",READ_QUEUE_OUT_VAL->read(),READ_QUEUE_OUT_ACK->read());
 	  if ((READ_QUEUE_OUT_VAL->read() == 1) and
 	      (READ_QUEUE_OUT_ACK->read() == 1))
@@ -535,5 +509,5 @@
 		rob_id = 0;
 	      Tcontext_t ctxt   = _ooo_engine_id [rob_id];
-	      LABEL("Accepted READ_QUEUE_OUT ["+toString(rob_id)+"]");
+	      LABEL("Accepted READ_QUEUE_OUT [%d]",rob_id);
 	      
 	      TEST(uint32_t          , rob_id ,request_out);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Read_queue.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Read_queue.h	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Read_queue.h	(revision 82)
@@ -17,7 +17,7 @@
 #include "Common/include/ToString.h"
 #include "Common/include/Debug.h"
-#include "Behavioural/include/Types.h"
 
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Parameters.h"
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Types.h"
 #ifdef STATISTICS
 #include "Behavioural/include/Stat.h"
@@ -27,4 +27,5 @@
 #include "Behavioural/include/Vhdl.h"
 #endif
+#include "Behavioural/include/Usage.h"
 
 namespace morpheo {
@@ -36,166 +37,4 @@
 namespace read_unit {
 namespace read_queue {
-  
-  class Tread_queue_entry_t
-  {
-  public    : Tcontext_t         _context_id   ;
-  public    : Tcontext_t         _front_end_id ;
-  public    : Tcontext_t         _ooo_engine_id;
-  public    : Tpacket_t          _rob_id       ;
-  public    : Toperation_t       _operation    ;
-  public    : Ttype_t            _type         ;
-  public    : Tlsq_ptr_t         _store_queue_ptr_write;
-  public    : Tlsq_ptr_t         _load_queue_ptr_write;
-  public    : Tcontrol_t         _has_immediat ;
-  public    : Tgeneral_data_t    _immediat     ;
-  public    : Tcontrol_t         _read_ra      ;
-  public    : Tgeneral_address_t _num_reg_ra   ;
-  public    : Tcontrol_t         _read_rb      ;
-  public    : Tgeneral_address_t _num_reg_rb   ;
-  public    : Tcontrol_t         _read_rc      ;
-  public    : Tspecial_address_t _num_reg_rc   ;
-  public    : Tcontrol_t         _write_rd     ;
-  public    : Tgeneral_address_t _num_reg_rd   ;
-  public    : Tcontrol_t         _write_re     ;
-  public    : Tspecial_address_t _num_reg_re   ;
-
-    friend std::ostream& operator<< (std::ostream& output_stream,
-				morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue::Tread_queue_entry_t & x)
-    {
-      output_stream << " * _context_id            : " << toString(x._context_id   ) << std::endl
-		    << " * _front_end_id          : " << toString(x._front_end_id ) << std::endl
-		    << " * _ooo_engine_id         : " << toString(x._ooo_engine_id) << std::endl
-		    << " * _rob_id                : " << toString(x._rob_id       ) << std::endl
-		    << " * _operation             : " << toString(x._operation    ) << std::endl
-		    << " * _type                  : " << toString(x._type         ) << std::endl
-		    << " * _store_queue_ptr_write : " << toString(x._store_queue_ptr_write) << std::endl
-		    << " * _load_queue_ptr_write  : " << toString(x._load_queue_ptr_write ) << std::endl
-		    << " * _has_immediat          : " << toString(x._has_immediat ) << std::endl
-		    << " * _immediat              : " << toString(x._immediat     ) << std::endl
-		    << " * _read_ra               : " << toString(x._read_ra      ) << std::endl
-		    << " * _num_reg_ra            : " << toString(x._num_reg_ra   ) << std::endl
-		    << " * _read_rb               : " << toString(x._read_rb      ) << std::endl
-		    << " * _num_reg_rb            : " << toString(x._num_reg_rb   ) << std::endl
-		    << " * _read_rc               : " << toString(x._read_rc      ) << std::endl
-		    << " * _num_reg_rc            : " << toString(x._num_reg_rc   ) << std::endl
-		    << " * _write_rd              : " << toString(x._write_rd     ) << std::endl
-		    << " * _num_reg_rd            : " << toString(x._num_reg_rd   ) << std::endl
-		    << " * _write_re              : " << toString(x._write_re     ) << std::endl
-		    << " * _num_reg_re            : " << toString(x._num_reg_re   ) << std::endl;
-
-      return output_stream;
-    }
-
-  };
-
-  class Tread_queue_head_entry_t
-  {
-  public    : Tcontext_t         _context_id   ;
-  public    : Tcontext_t         _front_end_id ;
-  public    : Tcontext_t         _ooo_engine_id;
-  public    : Tpacket_t          _rob_id       ;
-  public    : Toperation_t       _operation    ;
-  public    : Ttype_t            _type         ;
-  public    : Tlsq_ptr_t         _store_queue_ptr_write;
-  public    : Tlsq_ptr_t         _load_queue_ptr_write;
-  public    : Tcontrol_t         _has_immediat ;
-  public    : Tgeneral_data_t    _immediat     ;
-  public    : Tcontrol_t         _read_ra      ;
-  public    : Tcontrol_t         _read_ra_val  ; // 1 : must access at the registerFile (after access, is set at 0)
-  public    : Tgeneral_address_t _num_reg_ra   ;
-  public    : Tcontrol_t         _data_ra_val  ; // 1 : the read of registerFile is valid
-  public    : Tgeneral_data_t    _data_ra      ;
-  public    : Tcontrol_t         _read_rb      ;
-  public    : Tcontrol_t         _read_rb_val  ;
-  public    : Tgeneral_address_t _num_reg_rb   ;
-  public    : Tcontrol_t         _data_rb_val  ;
-  public    : Tgeneral_data_t    _data_rb      ;
-  public    : Tcontrol_t         _read_rc      ;
-  public    : Tcontrol_t         _read_rc_val  ;
-  public    : Tspecial_address_t _num_reg_rc   ;
-  public    : Tcontrol_t         _data_rc_val  ;
-  public    : Tspecial_data_t    _data_rc      ;
-  public    : Tcontrol_t         _write_rd     ;
-  public    : Tgeneral_address_t _num_reg_rd   ;
-  public    : Tcontrol_t         _write_re     ;
-  public    : Tspecial_address_t _num_reg_re   ;
-
-#undef  FUNCTION 
-#define FUNCTION "Tread_queue_head_entry_t::operator="
-  public    : Tread_queue_head_entry_t& operator=(Tread_queue_entry_t x)
-    {
-      log_printf(FUNC,Read_queue,FUNCTION,"Begin");
-	  
-      _context_id   = x._context_id   ;
-      _front_end_id = x._front_end_id ;
-      _ooo_engine_id= x._ooo_engine_id;
-      _rob_id       = x._rob_id       ;
-      _operation    = x._operation    ;
-      _type         = x._type         ;
-      _store_queue_ptr_write = x._store_queue_ptr_write;
-      _load_queue_ptr_write  = x._load_queue_ptr_write ;
-      _has_immediat = x._has_immediat ;
-      _immediat     = x._immediat     ;
-      _read_ra      = x._read_ra      ;
-      _read_ra_val  = x._read_ra == 1 ; //if not must read, the registerFile is already access
-      _num_reg_ra   = x._num_reg_ra   ;
-      _data_ra_val  = x._read_ra == 0 ; //if not must read, the data is already valid
-      _data_ra      = 0               ;
-      _read_rb      = x._read_rb      ;
-      _read_rb_val  = x._read_rb == 1 ;
-      _num_reg_rb   = x._num_reg_rb   ;
-      _data_rb_val  = x._read_rb == 0 ;
-      _data_rb      = 0               ;
-      _read_rc      = x._read_rc      ;
-      _read_rc_val  = x._read_rc == 1 ;
-      _num_reg_rc   = x._num_reg_rc   ;
-      _data_rc_val  = x._read_rc == 0 ;
-      _data_rc      = 0               ;
-      _write_rd     = x._write_rd     ;
-      _num_reg_rd   = x._num_reg_rd   ;
-      _write_re     = x._write_re     ;
-      _num_reg_re   = x._num_reg_re   ;
-
-      log_printf(FUNC,Read_queue,FUNCTION,"End");
-
-      return *this;
-    }
-
-    friend std::ostream& operator<< (std::ostream& output_stream,
-				morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue::Tread_queue_head_entry_t & x)
-    {
-      output_stream << " * _context_id            : " << x._context_id   << std::endl
-		    << " * _front_end_id          : " << x._front_end_id << std::endl
-		    << " * _ooo_engine_id         : " << x._ooo_engine_id<< std::endl
-		    << " * _rob_id                : " << x._rob_id       << std::endl
-		    << " * _operation             : " << x._operation    << std::endl
-		    << " * _type                  : " << x._type         << std::endl
-		    << " * _store_queue_ptr_write : " << toString(x._store_queue_ptr_write) << std::endl
-		    << " * _load_queue_ptr_write  : " << toString(x._load_queue_ptr_write ) << std::endl
-		    << " * _has_immediat          : " << x._has_immediat << std::endl
-		    << " * _immediat              : " << x._immediat     << std::endl
-		    << " * _read_ra               : " << x._read_ra      << std::endl
-		    << " * _read_ra_val           : " << x._read_ra_val  << std::endl 
-		    << " * _num_reg_ra            : " << x._num_reg_ra   << std::endl
-		    << " * _data_ra_val           : " << x._data_ra_val  << std::endl
-		    << " * _data_ra               : " << x._data_ra      << std::endl
-		    << " * _read_rb               : " << x._read_rb      << std::endl
-		    << " * _read_rb_val           : " << x._read_rb_val  << std::endl
-		    << " * _num_reg_rb            : " << x._num_reg_rb   << std::endl
-		    << " * _data_rb_val           : " << x._data_rb_val  << std::endl
-		    << " * _data_rb               : " << x._data_rb      << std::endl
-		    << " * _read_rc               : " << x._read_rc      << std::endl
-		    << " * _read_rc_val           : " << x._read_rc_val  << std::endl
-		    << " * _num_reg_rc            : " << x._num_reg_rc   << std::endl
-		    << " * _data_rc_val           : " << x._data_rc_val  << std::endl
-		    << " * _data_rc               : " << x._data_rc      << std::endl
-		    << " * _write_rd              : " << x._write_rd     << std::endl
-		    << " * _num_reg_rd            : " << x._num_reg_rd   << std::endl
-		    << " * _write_re              : " << x._write_re     << std::endl
-		    << " * _num_reg_re            : " << x._num_reg_re   << std::endl;
-
-      return output_stream;
-    }
-  };
 
   class Read_queue 
@@ -206,6 +45,7 @@
     // -----[ fields ]----------------------------------------------------
     // Parameters
-  protected : const std::string                _name;
-  protected : const Parameters               * _param;
+  protected : const std::string  _name;
+  protected : const Parameters * _param;
+  private   : const Tusage_t     _usage;
 
 #ifdef STATISTICS
@@ -345,5 +185,6 @@
 					      morpheo::behavioural::Parameters_Statistics * param_statistics,
 #endif
-					      Parameters                                  * param );
+					      Parameters                                  * param,
+					      morpheo::behavioural::Tusage_t                usage);
 					       
   public  :          Read_queue              (Parameters * param );
@@ -381,5 +222,4 @@
 }; // end namespace multi_execute_loop
 }; // end namespace core
-
 }; // end namespace behavioural
 }; // end namespace morpheo              
